

import java.util.ArrayList;

class GRAPHMATRIX{

    private ArrayList<KNOTEN> knoten;   
    private ArrayList<ArrayList<Integer>> matrix;
    private ArrayList<Integer> warteliste;
    private ArrayList<Integer> fertigeKnoten;
    
    GRAPHMATRIX (){
        knoten = new ArrayList<KNOTEN>();
        matrix = new ArrayList<ArrayList<Integer>>();
        warteliste = new ArrayList<Integer>();
        fertigeKnoten = new ArrayList<Integer>();
    }
      
    void ZurückSetzen(){
        knoten.clear();
        matrix.clear();
    }

    private KNOTEN KnotenGeben(String bezeichner){
        for (KNOTEN k: knoten){
            if (k.BezeichnerGeben().equals(bezeichner)){
                return k;
            }
        }
        return null;
    }

    int KnotenNummerGeben(String bezeichner){
        for (int index=0; index < knoten.size(); index++){
            if (knoten.get(index).BezeichnerGeben().equals(bezeichner)){
                return index;
            }
        }
        return -1;
    }
       
    String KnotenBezeichnerGeben(int knotenNummer){
        if ((knotenNummer < knoten.size()) && (knotenNummer >= 0)){
            return knoten.get(knotenNummer).BezeichnerGeben();
        }
        else{
            return "";
        }
    }

    void KanteEinfügen(String von, String nach, int gewichtung){
        int vonNummer, nachNummer;
        vonNummer = KnotenNummerGeben(von);
        nachNummer = KnotenNummerGeben(nach);
        if ((vonNummer!=-1) && (nachNummer!=-1) && (vonNummer!=nachNummer)){
            matrix.get(vonNummer).set(nachNummer, gewichtung);
            matrix.get(nachNummer).set(vonNummer, gewichtung);
        }
    }
        
    int KantenGewichtGeben(String von, String nach){
        int vonNummer, nachNummer;
        vonNummer = KnotenNummerGeben(von);
        nachNummer = KnotenNummerGeben(nach);
        if ((vonNummer!=-1) && (nachNummer!=-1)){
            return matrix.get(vonNummer).get(nachNummer);
        }
        else{
            return -1;
        }
    }
    
    void KnotenEinfügen(String bezeichner){
        int anzAlt = matrix.size();
        knoten.add(new KNOTEN(bezeichner));
        for (int index = 0; index < matrix.size(); index++){
            matrix.get(index).add(new Integer(-1));
        }
        matrix.add(new ArrayList<Integer>());
        for (int index = 0; index <=anzAlt;index++){
            matrix.get(anzAlt).add(new Integer(-1));
        }
    }

    void Ausgeben(){
        System.out.print("   ");  
        for (int i = 0; i < knoten.size(); i++){
            System.out.print((knoten.get(i).BezeichnerGeben() + "       ").substring(0, 3));
        }
        System.out.println();
        
        for (int i = 0; i < knoten.size(); i++){
            System.out.print((knoten.get(i).BezeichnerGeben() + "        ").substring(0, 3));
            for (int j = 0; j < knoten.size(); j++){
                if (matrix.get(i).get(j) != -1){
                    System.out.print((matrix.get(i).get(j)+ "       ").substring(0, 3));
                }
                else{
                    System.out.print("   ");
                }
            }
            System.out.println();           
        }
    }    
    
    void BreitensucheAusführen (int sKnr, int zKnr){
        warteliste.clear();
        fertigeKnoten.clear();
        int aKnr = sKnr;
        do {
            for (int nr = 0; nr < knoten.size(); nr++){
                if ((matrix.get(aKnr).get(nr) > 0) && 
                    (!fertigeKnoten.contains(nr)) && 
                    (! warteliste.contains(nr))){
                    warteliste.add(nr);
                }
            }
            fertigeKnoten.add(aKnr);
            aKnr = warteliste.get(0);
            warteliste.remove(0);
        }while ((aKnr != zKnr) && warteliste.size()>0);
        if (aKnr == zKnr){
            System.out.println("Ziel erreicht");
        }else{
            System.out.println("Besuchsreihenfolge:");            
        }
        for(Integer i: fertigeKnoten){
            System.out.println(KnotenBezeichnerGeben(i));
        }
        System.out.println(KnotenBezeichnerGeben(aKnr));
    }
}
